#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>

typedef enum{
  DS_NONE,/* normal.*/
    DS_WAIT_DIR,/* wait for file listing in directory */
    DS_WAIT_FOP,/* wait for file operation(copy, remove...) */
    DS_WAIT_NET,/* wait for network connection */
    DS_WAIT_DIALOG,/* when popup dialog */
    DS_BUSY
}df_stat;

/* dialog operation */
typedef enum{
  DO_COPY,
    DO_MOVE,
    DO_RENAME,
    DO_DELETE,
    DO_ATTR,
    DO_LINK
}df_opcode;

typedef struct _dfFile{
  char *pszName;
  mode_t attr;
  int color;
  off_t size;
  uid_t owner;
  gid_t group;
  time_t atime;
  time_t mtime;
  time_t ctime;
  int nSelect;
}DfFile;

typedef struct _dfFileList DfFileList;
typedef struct _dfWindow DfWindow;

struct _dfWindow{
  DfFileList *lists;
  Widget w;
  int width;
  int height;
  int fClipping;
  XRectangle clip;
};

struct _dfFileList{
  DfFile *files;
  df_stat stat;
  DfFileList *next;
  DfFileList *prev;
  int nCur;
  int nStart;
  int nFiles;
  int nSelects;
  char *pszCurDir;
  char *pszFilenames;
  XRectangle rc;
};

typedef struct _dfDialog{
  DfFileList *list;
  Widget shell;
  df_opcode op;
  int (*invoke)(void *);
  char *files;
}DfDialog;


typedef struct _dfStr{
  char *str;
  int cnt;
  int len;/* used length of strings */
  int alloced_len;/*  allocated length */
}DfStr;


extern XFontSet vFontSet;
extern int vnFontHeight;
extern int vnFontBase;
enum{
  COLOR_BK,
  COLOR_FILE,
  COLOR_DIR,
  COLOR_LINK,
  COLOR_RO,
  COLOR_X,
  COLOR_DEV,
  COLOR_OTHER,
  COLOR_CURFG,
  COLOR_CURBG,
  COLOR_SELFG,
  COLOR_SELBG,
  COLOR_MARK,
  COLOR_MAX
};
extern int colors[COLOR_MAX];
