/* dfx function declare */
/* filer window */
void Wnd_Create(Widget parent, int cx, int cy);
void Wnd_Initialize(Widget w, DfWindow *wnd);

/*
 * strings
 */
int Str_Init(DfStr *s);
int Str_InitStr(DfStr *s, const char *str);
int Str_InitPsz(DfStr *s, const char *str);
int Str_Free(DfStr *s, int fFree);
char *Str_Get(DfStr *s);
int Str_Length(DfStr *s);
void Str_SetLength(DfStr *s, int len);
int Str_Add(DfStr *s, const char *str);
int Str_AddNUL(DfStr *s, const char *str);
int Str_AddChar(DfStr *s, char ch);
int Str_Overwrite(DfStr *s, int idx, const char *str);
int Str_Shrink(DfStr *s);
int Str_RegPath(DfStr *s);

/*
 * directories
 */
int GetFiles(DfFileList *pList, const char *new_dir);


/*
 * utility
 */
int IsAbsPath(const char *path);
int IsEndSlash(DfStr *path);
void SetLastSlash(DfStr *path);
void AddRect(XRectangle *rc, int x, int y, int width, int height);
int MakeSelectList(DfStr *s, DfFileList *list);
unsigned long xAllocColor(Display *d, const char *color);
char *FindLastChar(char *p, char c);
void InvalidateWindow(Widget w);


#if MEMDEBUG
#define bMalloc(A) dbgMalloc(A, __FILE__, __FUNCTION__, __LINE__)
#define bReAlloc(A,B) dbgReAlloc(A,B,__FILE__, __FUNCTION__, __LINE__)
#define bFree(A) dbgFree(A,__FILE__, __FUNCTION__, __LINE__)
void *dbgMalloc(int size, const char *file, const char *func, int line);
void *dbgReAlloc(void *ptr, int size, const char *file, const char *func, int line);
void dbgFree(void *ptr, const char *file, const char *func, int line);
void DumpMemInfo(void);
#else
#define bMalloc(A) malloc(A)
#define bReAlloc(A,B) realloc(A,B)
#define bFree(A) free(A)
#endif
