#include <stdio.h>
#include <stdlib.h>
#include <signal.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include "dftype.h"
#include "dfxfunc.h"

Widget toplevel;
XFontSet vFontSet;
int vnFontHeight;
int vnFontBase;
int colors[COLOR_MAX];


extern void action_quit(Widget w, XEvent *ev, String *s, Cardinal *c);
static void AppInitialize(Widget w);

static char *fallback_resources[] ={
//  "dfx.width: 320",
//  "dfx.hieght: 200",
  "dfx.dlg.dialog.width: 160",
  "dfx.dlg.dialog.height: 200",
  "dfx.dlg.dialog.horizDistance: 2",
  "dfx.dlg.dialog.vertDistance: 2",
  "*text.colums: 24",
  "*text.value: \".\"",
  NULL
};


static XtActionsRec actions[] = {
  {"quit", action_quit}
};

void action_quit(Widget w, XEvent *ev, String *s, Cardinal *c)
{
  fprintf(stderr, "quit.\n");
  XtCloseDisplay(XtDisplay(w));
  exit(0);
}

int main(int argc, char **argv)
{
  XtAppContext ac;
  static String translate = "<Message>WM_PROTOCOLS: quit()";

  toplevel = XtAppInitialize(&ac, "dfx", NULL, 0,
			     &argc, argv, fallback_resources, NULL, 0);
  AppInitialize(toplevel);
  Wnd_Create(toplevel, 150, 120);
  //  XtAppAddActions(ac, actions, XtNumber(actions));
  //  XtOverrideTranslations(toplevel, XtParseTranslationTable(translate));
  XtRealizeWidget(toplevel);
  XtAppMainLoop(ac);

  return 0;
}

static void AppInitialize(Widget w)
{
  char **miss;
  int miss_charset;
  char *def;
  XFontSetExtents *fse;
  Display *d;

  d = XtDisplay(w);
  colors[COLOR_BK] = xAllocColor(d, "white");
  colors[COLOR_FILE] = xAllocColor(d, "black");
  colors[COLOR_RO] = xAllocColor(d, "red");
  colors[COLOR_X] = xAllocColor(d, "green");
  colors[COLOR_DIR] = xAllocColor(d, "blue");
  colors[COLOR_CURBG] = xAllocColor(d, "black");
  colors[COLOR_CURFG] = xAllocColor(d, "white");
  colors[COLOR_SELBG] = xAllocColor(d, "blue");
  colors[COLOR_SELFG] = xAllocColor(d, "white");
  colors[COLOR_MARK] =  xAllocColor(d, "yellow");

  vFontSet = XCreateFontSet(
			    d,
			    "-*-*-medium-r-normal--12-*",
			    &miss, &miss_charset, &def);

  fse = XExtentsOfFontSet(vFontSet);
  vnFontHeight = fse->max_logical_extent.height;  
  vnFontBase = -fse->max_logical_extent.y;
}
